# Record Class SyRenderNodeShape

java.lang.Object
java.lang.Record
com.io7m.jsycamore.api.rendering.SyRenderNodeShape

Record Components:
  `name` - The node name, for debugging purposes
  `position` - The position offset for this node
  `edgePaint` - The edge paint
  `fillPaint` - The fill paint
  `shape` - The shape

All Implemented Interfaces:
  `SyRenderNodePrimitiveType, SyRenderNodeType`

public record SyRenderNodeShape(String name, com.io7m.jtensors.core.parameterized.vectors.PVector2I<SySpaceComponentRelativeType> position, Optional<SyPaintEdgeType> edgePaint, Optional<SyPaintFillType> fillPaint, SyShapeType<SySpaceComponentRelativeType> shape) extends Record implements SyRenderNodePrimitiveType
A render node consisting of a shape.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SyRenderNodeShape(String name, com.io7m.jtensors.core.parameterized.vectors.PVector2I<SySpaceComponentRelativeType> position, Optional<SyPaintEdgeType> edgePaint, Optional<SyPaintFillType> fillPaint, SyShapeType<SySpaceComponentRelativeType> shape)`
  A render node consisting of a shape.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Optional<SyPaintEdgeType>`
  `edgePaint()`
  Returns the value of the `edgePaint` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `Optional<SyPaintFillType>`
  `fillPaint()`
  Returns the value of the `fillPaint` record component.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `String`
  `name()`
  Returns the value of the `name` record component.
  `com.io7m.jtensors.core.parameterized.vectors.PVector2I<SySpaceComponentRelativeType>`
  `position()`
  Returns the value of the `position` record component.
  `SyShapeType<SySpaceComponentRelativeType>`
  `shape()`
  Returns the value of the `shape` record component.
  `com.io7m.jregions.core.parameterized.sizes.PAreaSizeI<SySpaceComponentRelativeType>`
  `size()`
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface SyRenderNodeType

  `boundingArea`

- ## Constructor Details

  - ### SyRenderNodeShape

    public SyRenderNodeShape(String name, com.io7m.jtensors.core.parameterized.vectors.PVector2I<SySpaceComponentRelativeType> position, Optional<SyPaintEdgeType> edgePaint, Optional<SyPaintFillType> fillPaint, SyShapeType<SySpaceComponentRelativeType> shape)
    A render node consisting of a shape.
    Parameters:
      `name` - The node name, for debugging purposes
      `position` - The position offset for this node
      `edgePaint` - The edge paint
      `fillPaint` - The fill paint
      `shape` - The shape

- ## Method Details

  - ### size

    public com.io7m.jregions.core.parameterized.sizes.PAreaSizeI<SySpaceComponentRelativeType> size()
    Specified by:
      `size` in interface `SyRenderNodeType`
    Returns:
      The size of the node

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### name

    public String name()
    Returns the value of the `name` record component.
    Specified by:
      `name` in interface `SyRenderNodeType`
    Returns:
      the value of the `name` record component

  - ### position

    public com.io7m.jtensors.core.parameterized.vectors.PVector2I<SySpaceComponentRelativeType> position()
    Returns the value of the `position` record component.
    Specified by:
      `position` in interface `SyRenderNodeType`
    Returns:
      the value of the `position` record component

  - ### edgePaint

    public Optional<SyPaintEdgeType> edgePaint()
    Returns the value of the `edgePaint` record component.
    Returns:
      the value of the `edgePaint` record component

  - ### fillPaint

    public Optional<SyPaintFillType> fillPaint()
    Returns the value of the `fillPaint` record component.
    Returns:
      the value of the `fillPaint` record component

  - ### shape

    public SyShapeType<SySpaceComponentRelativeType> shape()
    Returns the value of the `shape` record component.
    Returns:
      the value of the `shape` record component